unit Main.Form;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ListLabel28, FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf, FireDAC.Stan.StorageBin, Data.DB, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm2 = class(TForm)
    ListLabel: TListLabel28;
    tblMaster: TFDMemTable;
    tblDetail: TFDMemTable;
    tblAdressen: TFDMemTable;
    dsMaster: TDataSource;
    dsDetail: TDataSource;
    dsAdressen: TDataSource;
    btnDesign: TButton;
    pnlRight: TPanel;
    pnlMain: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure btnDesignClick(Sender: TObject);
    procedure ListLabelAutoDefineNewPage(Sender: TObject; IsDesignMode: Boolean);
  private
    procedure InitializeReport;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation

uses
  System.IOUtils, LLReport_Types, cmbtLL28x;

{$R *.dfm}

type
  TListLabelHelper = class helper for TListLabel28
  public
    procedure DefineDateTimeVariable(const AName: string; AValue: TDateTime);
    procedure DefineVariable(const AName: string; AValue: Boolean); overload;
    procedure DefineVariable(const AName: string; AValue: Double); overload;
    procedure DefineVariable(const AName: string; AValue: Integer); overload;
    procedure DefineVariable(const AName, AValue: string); overload;
    procedure DefineVariable(const AName: string; AValue: TIcon); overload;
  end;

procedure TListLabelHelper.DefineDateTimeVariable(const AName: string; AValue: TDateTime);
begin
  Core.LlDefineVariableExt(AName, Double(AValue).ToString(TFormatSettings.Invariant), LL_DATE_DELPHI);
end;

procedure TListLabelHelper.DefineVariable(const AName: string; AValue: Boolean);
const
  cBool: array[Boolean] of string = ('F', 'T');
begin
  Core.LlDefineVariableExt(AName, cBool[AValue], LL_BOOLEAN);
end;

procedure TListLabelHelper.DefineVariable(const AName: string; AValue: Double);
begin
  Core.LlDefineVariableExt(AName, AValue.ToString(TFormatSettings.Invariant), LL_NUMERIC);
end;

procedure TListLabelHelper.DefineVariable(const AName: string; AValue: Integer);
begin
  Core.LlDefineVariableExt(AName, AValue.ToString, LL_NUMERIC_INTEGER);
end;

procedure TListLabelHelper.DefineVariable(const AName, AValue: string);
begin
  Core.LlDefineVariableExt(AName, AValue, LL_TEXT);
end;

procedure TListLabelHelper.DefineVariable(const AName: string; AValue: TIcon);
begin
  Core.LlDefineVariableExtHandle(AName, AValue.Handle, LL_DRAWING_HICON);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  InitializeReport;
end;

procedure TForm2.btnDesignClick(Sender: TObject);
begin
  ListLabel.Design;
end;

procedure TForm2.InitializeReport;
begin
  ListLabel.DataController.DataSource := dsMaster;

  var master := ListLabel.DataController.DetailSources.Add;
  master.Name := 'MasterSource';
  master.DataSource := dsMaster;
  master.PrimaryKeyField := 'VETYP';
  ListLabel.DataController.DataMember := master.Name;
  ListLabel.DataController.AutoMasterMode := mmAsVariables;

  var detail := master.Add;
  detail.Name := 'DetailSource';
  detail.DataSource := dsDetail;
  detail.PrimaryKeyField := 'PE_KEY';
  detail.DetailKeyField := 'VETYP';
  detail.MasterKeyField := 'VETYP';

  var adressen := detail.Add;
  adressen.Name := 'Adressdaten';
  adressen.DataSource := dsAdressen;
  adressen.PrimaryKeyField := 'PE_KEY';
  adressen.DetailKeyField := 'PE_KEY';
  adressen.MasterKeyField := 'PE_KEY';
end;

procedure TForm2.ListLabelAutoDefineNewPage(Sender: TObject; IsDesignMode: Boolean);
begin
  ListLabel.DefineVariable('ReportTitle', 'Adressliste');
  ListLabel.DefineVariable('Logo', Application.Icon);
end;

end.
